Ext.namespace('dSA', 'dSA.functions', 'dSA.actions',
              'dSA.actions.transmission', 'dSA.actions.presence',
              'dSA.actions.identifydevice', 'dSA.actions.dsmsettings',
              'dSA.actions.dsmfreqsettings');

dSA.ReactorImpl = Ext.extend(Ext.util.Observable, {
    constructor: function(config) {
        this.addEvents(
            'checktransmissionquality', // dSM display ID, dSM dSID, dSM dSUID,
                                        // dSM name, mask element
            'reregisterdevices',        // dSM dSUID
            'checkdevicepresence',      // dSM display ID, dSM dSUID,
                                        // dSM name, interval
            'blinkdsmled',              // dSM dSUID
            'checksingledevicepresence',// device display ID, device dSID,
                                        // device dSUID, dSM dSUID, device name
                                        // device present, mask element
            'identifydevice',           // device store, meter store,
                                        // mask element
            'showreport',               // report request type, task type, title
            'dsmsettings',              // dSM display ID, dSM dSID, dSM dSUID,
                                        // dSM name, mask element
            'dsmfreqsettings',          // mask element
            'modifydevicepulse',        // mask element
            'resetdevicepulse'          // mask element
        );
        dSA.ReactorImpl.superclass.constructor.call(this, config);
    }
});

dSA.Reactor = (function() {
    return new dSA.ReactorImpl();
})();

dSA.Reactor.on('reregisterdevices', dSA.functions.ReregisterDevices);
dSA.Reactor.on('checktransmissionquality', dSA.actions.transmission.Test);
dSA.Reactor.on('checkdevicepresence', dSA.actions.presence.Test);
dSA.Reactor.on('blinkdsmled', dSA.functions.BlinkLEDonDSM);
dSA.Reactor.on('checksingledevicepresence', dSA.actions.singlepresence.Test);
dSA.Reactor.on('identifydevice', dSA.actions.identifydevice.IdentifyDevice);
dSA.Reactor.on('showreport', dSA.actions.ShowReport);
dSA.Reactor.on('dsmsettings', dSA.actions.dsmsettings.ShowdSMSettingsDialog);
dSA.Reactor.on('dsmfreqsettings', dSA.actions.dsmfreqsettings.ShowdSMFrequencySettingsDialog);
dSA.Reactor.on('modifydevicepulse', dSA.functions.ModifyDevicePulse);
dSA.Reactor.on('resetdevicepulse', dSA.functions.ResetDevicePulse);
